"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var utils_1 = require("./utils");
var rxjs_1 = require("rxjs");
var Controller = /** @class */ (function () {
    function Controller(initialState) {
        this._state = initialState;
        this._subject = new rxjs_1.Subject();
    }
    Object.defineProperty(Controller.prototype, "observable", {
        get: function () {
            return this._subject.asObservable();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Controller.prototype, "state", {
        get: function () {
            return this._state;
        },
        enumerable: false,
        configurable: true
    });
    Controller.prototype.emit = function (state) {
        var newState = tslib_1.__assign(tslib_1.__assign({}, this._state), state);
        if ((0, utils_1.isEquals)(newState, this._state)) {
            return;
        }
        this._state = newState;
        this._subject.next(this._state);
    };
    Controller.prototype.dispose = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._subject.complete();
                return [2 /*return*/];
            });
        });
    };
    return Controller;
}());
exports.default = Controller;
//# sourceMappingURL=Controller.js.map