"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useControllerInternal = exports.useController = void 0;
var react_1 = require("react");
var error_1 = require("./error");
function useController(context) {
    return useControllerInternal(context);
}
exports.useController = useController;
function useControllerInternal(source) {
    try {
        var controller = (0, react_1.useContext)(source._context);
        if (controller === undefined) {
            throw new error_1.ControllerNotProvided("The requested controller is not provided in scope, make sure you have wrap it's Provider");
        }
        return controller;
    }
    catch (err) {
        if (err instanceof error_1.ControllerNotProvided) {
            throw err;
        }
        return source;
    }
}
exports.useControllerInternal = useControllerInternal;
//# sourceMappingURL=useController.js.map