import { useContext } from 'react';
import { ControllerNotProvided } from './error';
function useController(context) {
    return useControllerInternal(context);
}
function useControllerInternal(source) {
    try {
        var controller = useContext(source._context);
        if (controller === undefined) {
            throw new ControllerNotProvided("The requested controller is not provided in scope, make sure you have wrap it's Provider");
        }
        return controller;
    }
    catch (err) {
        if (err instanceof ControllerNotProvided) {
            throw err;
        }
        return source;
    }
}
export { useController, useControllerInternal };
//# sourceMappingURL=useController.js.map